#!/bin/sh -e


# Default settings
defcfg="config-default"
rebuild="n"
makeflags=""
makejobs="-j 4"

usage() {
  echo "Usage: $0 {rebuild|silent|verbose|single}"
  exit 1
}

make_clean() {
  echo "**** Cleaning...."
  make ${makeflags} distclean
}

make_config() {
  echo "**** Configuring..."
  cp ${defcfg} .config
  make ${makeflags} oldconfig > /dev/null
}

make_build() {
  echo "**** Building..."
  make ${makeflags} ${makejobs}
}

make_install()
{
  echo "**** Installing..."
  make ${makeflags} install
}

# Main starts here
while test -n "$1"; do
  case "$1" in
  rebuild)
    rebuild="y"
    ;;
  silent)
    makeflags="-s"
    ;;
  verbose)
    makeflags=""
    ;;
  single)
    makejobs=""
    ;;
  *)
    usage
    ;;
  esac
  shift
done

if test "${rebuild}" = "y"; then
  echo "**** Rebuilding busybox..."
  make_clean
  make_config
elif test ! -f .config; then
  echo "**** Building busybox..."
  make_config
fi

make_build
make_install

echo "**** Successfully built busybox:"
ls -l _install/bin/busybox

# EOF
